package cc.smtweb.system.bpm.test;

import cc.smtweb.system.bpm.util.CodeGenUtil;
import org.apache.commons.lang3.StringUtils;
import org.junit.Test;

/**
 * Created by Akmm at 2022/3/1 9:41
 * 生成bean
 */
public class BuildJavaBean {
    @Test
    public void buildBean() {
        String str = "`tb_id` bigint(20) NOT NULL,\n" +
                "  `tb_prj_id` bigint(20) DEFAULT NULL,\n" +
                "  `tb_mc_id` bigint(20) NOT NULL,\n" +
                "  `tb_db_id` bigint(20) NOT NULL COMMENT '数据库id',\n" +
                "  `tb_extends` varchar(200) COLLATE utf8_unicode_ci DEFAULT NULL COMMENT '继承关系',\n" +
                "  `tb_name` varchar(32) COLLATE utf8_unicode_ci NOT NULL COMMENT '名称',\n" +
                "  `tb_title` varchar(200) COLLATE utf8_unicode_ci NOT NULL COMMENT '表中文名称',\n" +
                "  `tb_abbr` varchar(32) COLLATE utf8_unicode_ci DEFAULT NULL COMMENT '缩写，用于字段和索引组成',\n" +
                "  `tb_type` tinyint(4) NOT NULL DEFAULT '0' COMMENT '类别：0-普通表，1 树型表 2 编码表 9-虚拟抽象表 11 视图',\n" +
                "  `tb_need_cache` tinyint(4) NOT NULL DEFAULT '0' COMMENT '需要缓存',\n" +
                "  `tb_content` text COLLATE utf8_unicode_ci COMMENT '表详细信息',\n" +
                "  `tb_create_uid` bigint(20) DEFAULT NULL,\n" +
                "  `tb_update_uid` bigint(20) DEFAULT NULL,\n" +
                "  `tb_create_at` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间',\n" +
                "  `tb_update_at` bigint(20) NOT NULL DEFAULT '0' COMMENT '更新时间',\n";
        String[] ss = str.split("\n");
        for (String s: ss) {
            String[] s0 = s.trim().split(" ");
            if (StringUtils.isEmpty(s0[0])) continue;
            String tn = s0[0].substring(1, s0[0].indexOf("`", 2));
            String tnu = CodeGenUtil.underlineToUpperHump(tn.substring(tn.indexOf("_") + 1));
            String tnn = CodeGenUtil.underlineToHump(tn);

            String tt = s0[1];
            String ttj;
            if (tt.contains("(")) tt = tt.substring(0, tt.indexOf("("));
            switch (tt) {
                case "bigint":
                    tt = "long";
                    ttj = "Long";
                    break;
                case "tinyint":
                    case "int":
                    tt = "int";
                    ttj = "Int";
                    break;
                default:
                    tt = "String";
                    ttj = "Str";
                    break;
            }
            System.out.println("public " + tt + " get" + tnu + "(){\n" +
                    "return get" + ttj + "(\"" + tn + "\");\n" +
                    "}\n" +
                    "" +
                    "public void set" + tnu + "(" + tt + " " + tnn + "){\n" +
                    "put(\"" + tn + "\", " + tnn + ");\n" +
                    "}\n");
        }
    }
}
